package com.xk72.charles.gui.settings;

import com.xk72.charles.CharlesContext;
import com.xk72.charles.config.ExternalProxyConfiguration;
import com.xk72.charles.gui.lib.FormUtils;
import com.xk72.charles.gui.settings.AbstractImportExportSettingsPanel;
import com.xk72.charles.gui.settings.AlzL;
import com.xk72.charles.gui.settings.ExternalProxySettingsPanel$ProxyTypesTableModel;
import com.xk72.charles.gui.settings.JqXM;
import com.xk72.charles.gui.settings.nnsC;
import java.awt.Dimension;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.table.JTableHeader;
import net.miginfocom.swing.MigLayout;

public class ExternalProxySettingsPanel extends AbstractImportExportSettingsPanel {

   private static final String[] FwRs = new String[]{"http", "https", "socks"};
   private static final String[] GSXJ = new String[]{"Web代理(HTTP)", "安全Web代理(HTTPS)", "SOCKS 代理"};
   private static final String[] InuZ = new String[]{"Web代理服务器", "安全Web代理服务器", "SOCKS代理服务器"};
   private static final boolean[] Gwbn = new boolean[]{true, true, false};
   private final com.xk72.proxy.jSAY[] configs = new com.xk72.proxy.jSAY[3];
   private com.xk72.proxy.jSAY editingConfig;
   private final JLabel lProxyHeading = new JLabel();
   private final JTextField fProxyHost = new JTextField(10);
   private final JTextField fProxyPort = new JTextField(4);
   private final JCheckBox bRequiresAuthentication = new JCheckBox("代理服务器需要密码");
   private final JLabel lProxyDomain = new JLabel("域:");
   private final JLabel lProxyUsername = new JLabel("用户名:");
   private final JLabel lProxyPassword = new JLabel("密码:");
   private final JTextField fProxyDomain = new JTextField(10);
   private final JTextField fProxyUsername = new JTextField(10);
   private final JPasswordField fProxyPassword = new JPasswordField(10);
   private final JLabel lExternalProxyBypass = new JLabel("绕过以下主机的外部代理:");
   private final JCheckBox bAlwaysBypassLocalhost = new JCheckBox("总是绕过本地主机的外部代理");
   private final JTextArea fExternalProxyBypass = new JTextArea(4, 20);
   private final JCheckBox bEnabled = new JCheckBox("使用外部代理服务器");
   private final JLabel lProtocolsTable = new JLabel("选择要配置的协议:");
   private final JTable protocolsTable = new JTable(new ExternalProxySettingsPanel$ProxyTypesTableModel(this));
   private final JTextArea lProxyEditorHelp = FormUtils.Wczh("只有Windows身份验证(NTLM)需要域字段.");
   private boolean showDomainEditor;


   public ExternalProxySettingsPanel() {
      super(CharlesContext.getInstance().getBundle().getString("settings.externalproxy.name"));
      this.setHelp(CharlesContext.getInstance().getBundle().getString("settings.externalproxy.help"));
      this.bEnabled.addActionListener(new nnsC(this));
      this.protocolsTable.setPreferredScrollableViewportSize(new Dimension(100, 50));
      this.protocolsTable.setTableHeader((JTableHeader)null);
      this.protocolsTable.setRowSelectionAllowed(true);
      this.protocolsTable.getSelectionModel().setSelectionMode(0);
      this.protocolsTable.setShowGrid(false);
      this.protocolsTable.getColumnModel().getColumn(0).setMaxWidth(30);
      this.protocolsTable.getSelectionModel().setSelectionInterval(0, 0);
      this.protocolsTable.getSelectionModel().addListSelectionListener(new JqXM(this));
      com.xk72.charles.gui.lib.GMvq.FwRs(this.protocolsTable, String.class);
      com.xk72.charles.gui.lib.GMvq.FwRs(this.protocolsTable, Boolean.class);
      this.bRequiresAuthentication.addChangeListener(new AlzL(this));
      JPanel var1;
      (var1 = new JPanel(new MigLayout("wrap, fill, ins 0", "[grow, fill]20lp[grow, fill]", "[]u[grow,fill]20lp[]r[]r[]"))).add(this.bEnabled, "span");
      JPanel var2;
      (var2 = new JPanel(new MigLayout("wrap, fill, ins 0", "[fill, grow]", "[]r[fill, grow]"))).add(this.lProtocolsTable);
      var2.add(new JScrollPane(this.protocolsTable));
      var1.add(var2);
      (var2 = new JPanel(new MigLayout("wrap, fill, ins 0", "[]r[grow,fill]", "[][][][][]"))).add(this.lProxyHeading, "span");
      var2.add(this.fProxyHost, "split 3,span,gapafter 5,grow 1");
      var2.add(new JLabel(":"), "gapafter 5");
      var2.add(this.fProxyPort);
      var2.add(this.bRequiresAuthentication, "span");
      var2.add(this.lProxyDomain, "label");
      var2.add(this.fProxyDomain);
      var2.add(this.lProxyUsername, "label");
      var2.add(this.fProxyUsername);
      var2.add(this.lProxyPassword, "label");
      var2.add(this.fProxyPassword);
      var2.add(this.lProxyEditorHelp, "span, grow");
      var1.add(var2);
      var1.add(this.lExternalProxyBypass, "span");
      var1.add(this.fExternalProxyBypass, "span");
      var1.add(this.bAlwaysBypassLocalhost, "span");
      this.add(var1);
   }

   public static void main(String[] var0) {
      (new ExternalProxySettingsPanel()).test();
   }

   protected void updateForm() {
      boolean var1 = this.bEnabled.isSelected();
      this.lExternalProxyBypass.setEnabled(var1);
      this.fExternalProxyBypass.setEnabled(var1);
      this.lProtocolsTable.setEnabled(var1);
      this.protocolsTable.setEnabled(var1);
      this.lProxyHeading.setEnabled(var1);
      this.fProxyHost.setEnabled(var1);
      this.fProxyPort.setEnabled(var1);
      this.bRequiresAuthentication.setEnabled(var1);
      boolean var2 = var1?this.bRequiresAuthentication.isSelected():false;
      this.lProxyDomain.setEnabled(this.showDomainEditor && var2);
      this.lProxyUsername.setEnabled(var2);
      this.lProxyPassword.setEnabled(var2);
      this.fProxyDomain.setEnabled(this.showDomainEditor && var2);
      this.fProxyUsername.setEnabled(var2);
      this.fProxyPassword.setEnabled(var2);
      this.lProxyEditorHelp.setEnabled(this.showDomainEditor && var2);
      this.bAlwaysBypassLocalhost.setEnabled(var1);
   }

   private void FwRs(int param1) {
      // $FF: Couldn't be decompiled
   }

   private void InuZ() {
      if(this.editingConfig != null) {
         this.editingConfig.setHost(this.fProxyHost.getText());

         try {
            this.editingConfig.setPort(Integer.parseInt(this.fProxyPort.getText()));
         } catch (Exception var1) {
            this.editingConfig.setPort(0);
         }

         this.editingConfig.setRequiresAuthentication(this.bRequiresAuthentication.isSelected());
         this.editingConfig.setDomain(this.fProxyDomain.getText());
         this.editingConfig.setUsername(this.fProxyUsername.getText());
         this.editingConfig.setPassword(new String(this.fProxyPassword.getPassword()));
      }

   }

   public boolean save() {
      this.InuZ();
      return super.save();
   }

   protected ExternalProxyConfiguration getConfiguration() {
      return this.ctx.getConfiguration().getExternalProxyConfiguration();
   }

   protected ExternalProxyConfiguration newConfiguration() {
      return new ExternalProxyConfiguration();
   }

   protected void getPanelConfiguration(ExternalProxyConfiguration var1) {
      for(int var2 = 0; var2 < 3; ++var2) {
         var1.setConfiguration(FwRs[var2], this.configs[var2]);
      }

      var1.setEnabled(this.bEnabled.isSelected());
      var1.setBypassDomains(com.xk72.charles.lib.Nyst.FwRs(this.fExternalProxyBypass.getText()));
      var1.setAlwaysBypassLocalhost(this.bAlwaysBypassLocalhost.isSelected());
   }

   protected void setPanelConfiguration(ExternalProxyConfiguration var1) {
      int var2;
      for(var2 = 0; var2 < 3; ++var2) {
         this.configs[var2] = var1.getConfiguration(FwRs[var2]).getMutable();
      }

      this.bEnabled.setSelected(var1.isEnabled());
      this.fExternalProxyBypass.setText(com.xk72.charles.lib.Nyst.FwRs(var1.getBypassDomains()));
      this.bAlwaysBypassLocalhost.setSelected(var1.isAlwaysBypassLocalhost());
      if((var2 = this.protocolsTable.getSelectedRow()) != -1) {
         this.FwRs(var2);
      }

      this.updateForm();
   }

   protected void configurationUpdated() {
      this.ctx.getProxyManager().eOaK();
   }

   // $FF: synthetic method
   static JTable FwRs(ExternalProxySettingsPanel var0) {
      return var0.protocolsTable;
   }

   // $FF: synthetic method
   static void FwRs(ExternalProxySettingsPanel var0, int var1) {
      var0.FwRs(var1);
   }

   // $FF: synthetic method
   static boolean GSXJ(ExternalProxySettingsPanel var0) {
      return var0.showDomainEditor;
   }

   // $FF: synthetic method
   static JCheckBox InuZ(ExternalProxySettingsPanel var0) {
      return var0.bRequiresAuthentication;
   }

   // $FF: synthetic method
   static JLabel Gwbn(ExternalProxySettingsPanel var0) {
      return var0.lProxyDomain;
   }

   // $FF: synthetic method
   static JLabel Wczh(ExternalProxySettingsPanel var0) {
      return var0.lProxyUsername;
   }

   // $FF: synthetic method
   static JLabel KRBh(ExternalProxySettingsPanel var0) {
      return var0.lProxyPassword;
   }

   // $FF: synthetic method
   static JTextField VdwQ(ExternalProxySettingsPanel var0) {
      return var0.fProxyDomain;
   }

   // $FF: synthetic method
   static JTextField hndF(ExternalProxySettingsPanel var0) {
      return var0.fProxyUsername;
   }

   // $FF: synthetic method
   static JPasswordField eOaK(ExternalProxySettingsPanel var0) {
      return var0.fProxyPassword;
   }

   // $FF: synthetic method
   static JTextArea HliR(ExternalProxySettingsPanel var0) {
      return var0.lProxyEditorHelp;
   }

   // $FF: synthetic method
   static String[] FwRs() {
      return FwRs;
   }

   // $FF: synthetic method
   static com.xk72.proxy.jSAY[] qkXP(ExternalProxySettingsPanel var0) {
      return var0.configs;
   }

   // $FF: synthetic method
   static String[] GSXJ() {
      return GSXJ;
   }

}
